



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>深入理解JavaWeb技术内幕之中文编码</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">深入理解JavaWeb技术内幕之中文编码</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 06:41:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>为什么要编码</h2>
<p>1.计算机中存储信息的最小单元是1个字节，所能表示的字符范围为0~255个。</p>
<p>2.人类要表示的符号太多，无法用1个字节来完全表示。</p>
<h2>常见的编码类型</h2>
<h3>ASCII码</h3>
<p>总共128个，用1个字节的低7位表示。0<sub>31是控制字符，32</sub>126是打印字符。</p>
<h3>ISO-8859-1</h3>
<p>涵盖了大多数西欧语言字符，应用最广泛，单字节编码，能表示256个字符。</p>
<h3>GB2312</h3>
<p>双字节编码，中文编码字符集，表示六千多个汉字。</p>
<h3>GBK</h3>
<p>GB2312的扩充版，能表示两万多个汉字，与GB2312向下兼容。</p>
<h3>GB18030</h3>
<p>单字节，双字节或者四字节都有，兼容GB2312，应用并不广泛。</p>
<h3>UTF-16</h3>
<p>具体定义了Unicode字符在计算机中的存取方法。用两个字节表示Unicode的转化格式，采用<strong>定长</strong>的表示方法，即不论什么字符都可以用两个字节表示。是Java的内存字符存储格式。</p>
<h3>UTF-8</h3>
<p>采用变长的表示方法，每个编码区域有不同的字码长度。不同类型的字符可以由1~6个字节组成。</p>
<h2>Java中哪里需要编码</h2>
<h3>I/O操作中的编码</h3>
<p>Reader类是Java I/O 中读取字符的父类，InputStream是读取字节的父类。InputStreamReader负责将读取的字节转换成字符，具体的转换过程由StreamDecoder来做，解码格式由用户指定。</p>
<p>所以涉及I/O操作的时候，一定要注意指定统一的Charset字符集，如果没有指定，将使用操作系统的默认编码，这样在跨环境时，会出问题</p>
<h3>内存操作的编码</h3>
<pre class="prettyprint linenums"><code>	String s = &quot;这是一段中文编码&quot;;<br />
	byte[] b = s.getBytes(&quot;UTF-8&quot;);<br />
	String n = new String(b,&quot;UTF-8&quot;);<br />
</code></pre>
<h2>Java 编码原理</h2>
<p>如果编码这样一句话</p>
<pre class="prettyprint linenums"><code>“编码 in Java”<br />
</code></pre>
<p>测试代码如下：</p>
<pre class="prettyprint linenums"><code>	package com.study;

	import java.io.UnsupportedEncodingException;

	public class test {<br />
		private static String str = &quot;编码 in Java&quot;;

		public static void printHexString(byte[] b) {<br />
			for (int i = 0; i &lt; b.length; i++) {<br />
				String hex = Integer.toHexString(b[i] &amp; 0xFF);<br />
				if (hex.length() == 1) {<br />
					hex = '0' + hex;<br />
				}<br />
				System.out.print(hex.toUpperCase());<br />
			}

		}

		public static void main(String[] args) {<br />
			try {<br />
				byte[] b = str.getBytes(&quot;ISO-8859-1&quot;);<br />
				String n = new String(b, &quot;ISO-8859-1&quot;);<br />
				/*测试其他编码格式只要将上面的参数改一下就行**/<br />
				printHexString(b);<br />
				System.out.println();<br />
				System.out.println(n);<br />
			} catch (UnsupportedEncodingException e) {<br />
				// TODO Auto-generated catch block<br />
				e.printStackTrace();<br />
			}

		}<br />
	}<br />
</code></pre>
<h3>按照ISO-8859-1编码</h3>
<p>ISO-8859-1会将它不认识的字符全部转换为“？”字符，将认识的字符按照单字节编码。如下图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021552340533246.png"></p>
<p>3F---？ 20---空格 其余的每个字母都用两个十六进制数字表示，即一个字节。</p>
<h3>按照GB2312编码</h3>
<p>如下图：<br /><br />
<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021553227743596.png"></p>
<p>可以看出来每个汉字用了两个字节编码，其余同上。但是GB2312只支持6763个汉字。</p>
<h3>按照GBK编码</h3>
<p>如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021553337789702.png"></p>
<p>结果与上面一模一样，所以GBK是和GB2312向下兼容。</p>
<h3>按照UTF-16编码</h3>
<p>将结果与上面的图进行比较，可以看出除了汉字编码，每个编码前面都多了两个00。<br /><br />
<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021553528251715.png"></p>
<p>这种编码效率非常高（规则简单嘛），但是要注意不同处理器的大小端问题。</p>
<h3>按照UTF-8编码</h3>
<p>可以看到，汉字用了三个字节表示，其余字母用一个字节。<br /><br />
<img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021554103007174.png"></p>
<h3>格式比较</h3>
<p>UTF-16适合在本地编码，不适合在网络之间进行传输，网络传输很容易损坏字节流，一旦损坏难以恢复；与之相比UTF-8更容易传输，因为它对ASCII码单字节传输，所以即使单个字符损坏，也不影响后面的其他字符。</p>
<p>UTF-8是理想的中文编码方式。</p>
<h2>Java Web中涉及到的编解码问题</h2>
<p><strong>在Java中一个char是16bit，两个字节。所以两个汉字用char存储，会占用4个字节空间。</strong></p>
<p>只要涉及到网络I/O的地方都有可能引起中文乱码。</p>
<p>在Web中常见的就是发起http请求。此时会有三个地方存在编码：URL,Cookie，Parameter.</p>
<h3>URL</h3>
<p>比如输入下面的一个URL</p>
<pre class="prettyprint linenums"><code>http://localhost:8080/examples/servlets/servlet/例子?author=编码<br />
</code></pre>
<p>就以Tomcat为例：</p>
<p>很显然，这是一个GET请求。在PathInfo和QueryString部分都出现了中文。在Firefox浏览器中，PathInfo 是UTF-8编码， QueryString是GBK编码。<br /><br />
而且，<strong>URL还有一条规则就是，会将非ASCII码的字符按照某种编码格式编码成16进制数字之后，前面再加上%号</strong>。</p>
<p>在Tomcat的安装目录下有一个Conf文件夹，里面有一个配置文件server.xml，打开该文件，如下图所示。</p>
<p><img referrerpolicy="no-referrer"src="https://images0.cnblogs.com/blog2015/760751/201507/021554310812859.png"></p>
<p>会发现，URI编码是“UTF-8”，如果没有的话，默认为 ISO-8859-1.<strong>所以有中文URL时，最好将URIEncoding设置为UTF-8编码。</strong></p>
<p>解析QueryString：</p>
<p>该解码字符集要么是Header中定义的Charset，要么是默认的ISO-8859-1。要使用ContentType中定义的编码，就要设置</p>
<p>所以，为了避免像上面那么麻烦应该尽量避免在URI中使用非ASCII字符。</p>
<h3>HTTP Header的编解码</h3>
<p>同理，不要在Header中传递非ASCII字符，如果一定要传递，先将这些字符用<br /><br />
org.apache.catalina.util.URLEncoder编码，然后添加到Header中。</p>
<h3>POST表单</h3>
<p>因为POST表单的参数提交方式与QueryString不同，它是通过HTTP的BODY传递到服务器端的。</p>
<p>页面上单击提交按钮，浏览器首先将根据ContentType的Charset编码格式对在表单中插入的参数进行编码，然后提交到服务器，在服务端，同样也是按照ContentTYpe的字符集进行解码。所以POST表单提交的参数一般不会出问题。</p>
<p>设置字符集编码的方式：</p>
<pre class="prettyprint linenums"><code>request.setCharacterEncoding(charset);<br />
</code></pre>
<p>注意：一定要在第一次调用request.getParameter方法之前就对编码进行设置。否则会按照默认的ISO-8859-1进行解析。</p>
<h3>HTTP BODY</h3>
<p>当用户请求的资源已经成功获取之后，这些内容将通过Response返回给客户端浏览器。这个过程需要先编码再解码。编解码的字符集设置</p>
<pre class="prettyprint linenums"><code>response.setCharacterEncoding(charset);<br />
</code></pre>
<p>并且通过Header的Content-Type返回给客户端，浏览器接收到返回的Socket流时将通过Content-Type的charset进行解码。</p>
<p>如果没有相应的设置，则浏览器将按照HTML中的中的charset进行解码。</p>
<h3>JDBC</h3>
<p>如果是MySQL,可以通过URL进行设置。</p>
<pre class="prettyprint linenums"><code>URL:“jdbc:mysql://localhost:3306/DB?useUnicode=true&amp;characterEncoding=GBK”.<br />
</code></pre>
<h3>JS</h3>
<p>引入js文件的编码格式与当前页面的编码格式不一样，会发生乱码。</p>
<p>JS中处理URL编码的函数有如下三个：</p>
<p>1.escape()</p>
<p>功能：将ASCII字母，标点符号，数字之外的其他字符转换成Unicode编码值，并且在编码值前加上&quot;%u&quot;.</p>
<p>2.encodeURI()</p>
<p>功能：将这个URL中的字符进行UTF-8编码，并且在每个码值前加%。</p>
<p>解码用decodeURI()</p>
<p>3.encodeURIComponent()</p>
<p>功能：除了对少数标点符号，字母，数字不编码之外，对其他任何符号都编码，通常用于将一个URL参数放在另外一个URL中。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qydwpdq.html">navigationController 去掉背景图片、去掉底部线条</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwjlpy8.html">Linux-Memory小记</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw5k5yq.html">C fwrite</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx5zkz8.html">第六篇T语言实例开发，多点找色应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4k0459.html">Mybatis原理分析之二：框架整体设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p66d4q.html">Type&period;GetField 修改类中私有字段。</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv46kjq.html">最小的k个数</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8enrpz8.html">VS2008&plus;GDI实现多幅图像的GIF动画制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmmxpl9.html">VC&plus;&plus;时间函数总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p7wj9.html">利用CSS的&commat;font-face属性 在网页中嵌入字体</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yjz53q.html">在eclipse中的tomcat内存设置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7kpx9.html">javascript点击图片放大的功能（原生）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvm4z1q.html">SQL SERVER 2012疑难问题解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9geroel8.html">redux中间件的原理&mdash;&mdash;从懵逼到恍然大悟</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekr2e8.html">django下命令行工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj755k8.html">微服务SpringCloud&mdash;Config Server对称加密</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kerd09.html">Python&lowbar;Bool</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5gxl7q.html">GUI学习之五&mdash;&mdash;QAbstractButton类学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jp075q.html">破解windows版idea</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjwk0q.html">AFN 请求报 415错误解决方案</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96oxpgv9.html">飘逸的python - 多条件排序及itemgetter的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdenp2j9.html">JDK动态代理例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mn32mrq.html">【mysql】1206 SQLSTATE&colon; HY000 &lpar;ER&lowbar;LOCK&lowbar;TABLE&lowbar;FULL&rpar; 问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv6e1yq.html">第二章IPC&mdash;&mdash;IPC与开启多进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x4p0m8.html">JAVA JNI学习</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmgo2e9.html">Parallel并行编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm2dvz9.html">SQL Server 2008空间数据应用系列七：基于Bing Maps&lpar;Silverlight&rpar; 的空间数据展现</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wo04xq.html">LINQ to SQL和Entity Framework对比与关联 （转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj03e49.html">C&num; Cookie编程</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdenkwz9.html">使用fdisk进行磁盘管理</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
